
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CollectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.create(
            {
                id: data.id || undefined,
        
        name_ar: data.name_ar
        ||
        null
            ,
            
        name_en: data.name_en
        ||
        null
            ,
            
        slug: data.slug
        ||
        null
            ,
            
        description_ar: data.description_ar
        ||
        null
            ,
            
        description_en: data.description_en
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        
        await collections.setProducts(data.products || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.collections.getTableName(),
                belongsToColumn: 'image',
                belongsToId: collections.id,
            },
            data.image,
            options,
        );
        

        return collections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const collectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name_ar: item.name_ar
            ||
            null
            ,
            
                name_en: item.name_en
            ||
            null
            ,
            
                slug: item.slug
            ||
            null
            ,
            
                description_ar: item.description_ar
            ||
            null
            ,
            
                description_en: item.description_en
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const collections = await db.collections.bulkCreate(collectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < collections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.collections.getTableName(),
                    belongsToColumn: 'image',
                    belongsToId: collections[i].id,
                },
                data[i].image,
                options,
            );
        }
        

        return collections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const collections = await db.collections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name_ar !== undefined) updatePayload.name_ar = data.name_ar;
        
        
        if (data.name_en !== undefined) updatePayload.name_en = data.name_en;
        
        
        if (data.slug !== undefined) updatePayload.slug = data.slug;
        
        
        if (data.description_ar !== undefined) updatePayload.description_ar = data.description_ar;
        
        
        if (data.description_en !== undefined) updatePayload.description_en = data.description_en;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await collections.update(updatePayload, {transaction});

        
        

        
        
        if (data.products !== undefined) {
            await collections.setProducts(data.products, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.collections.getTableName(),
                belongsToColumn: 'image',
                belongsToId: collections.id,
            },
            data.image,
            options,
        );
        

        return collections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of collections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of collections) {
                await record.destroy({transaction});
            }
        });


        return collections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.findByPk(id, options);

        await collections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await collections.destroy({
            transaction
        });

        return collections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const collections = await db.collections.findOne(
            { where },
            { transaction },
        );

        if (!collections) {
            return collections;
        }

        const output = collections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.image = await collections.getImage({
            transaction
        });
        
        
        output.products = await collections.getProducts({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [


      {
        model: db.products,
        as: 'products',
        required: false,
      },


      {
        model: db.file,
        as: 'image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'name_ar',
                        filter.name_ar,
                    ),
                };
            }
            
            if (filter.name_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'name_en',
                        filter.name_en,
                    ),
                };
            }
            
            if (filter.slug) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'slug',
                        filter.slug,
                    ),
                };
            }
            
            if (filter.description_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'description_ar',
                        filter.description_ar,
                    ),
                };
            }
            
            if (filter.description_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'collections',
                        'description_en',
                        filter.description_en,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            



      if (filter.products) {
        const searchTerms = filter.products.split('|');

        include = [
          {
            model: db.products,
            as: 'products_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name_ar: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.collections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'collections',
                        'name_ar',
                        query,
                    ),
                ],
            };
        }

        const records = await db.collections.findAll({
            attributes: [ 'id', 'name_ar' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name_ar', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name_ar,
        }));
    }

    
};

